
# oklevels is a Tcl list that contains the sudoku difficulty levels you
# are willing to play.
#
# For example, to accept any level:
#
# set oklevels [list easy medium hard fiendish]
# 
# I, however, do not want easy...nor do I want insanely difficult.  Medium
# got too easy, so I always go with the "hard" level.  And then that got
# too easy, and I needed insanely-difficult, aka fiendish.... But for the
# distribution, I'm resetting it to all levels.

set oklevels [list easy medium hard fiendish]
# set oklevels [list fiendish ]

# Add a binding---N loads a new board, without asking
bind Entry  <Key-N> {nclearall ; getboard 1 ; loadnotesboard }

# With cheats enabled, right-clicking (button 3---the far-right on a
# right-handed mouse) in a square in the main board (i.e., not the
# notes board) solves for that square, or generates an error if there
# is no solution.  It can also be used the way I use it---as a
# keyboard-free way to enter the value for a square I just solved---this
# avoids some brain surgery-induced visual oddities that cause me to put
# stuff in one square, when I meant to put it in another.  Hey, it works...
# Just remember not to use that to cheat...after all, what fun is that?

set allow_cheats 1 ;# I use it to fill in the squares AFTER I solve them

# DO NOT TOUCH THESE unless you know exactly what you're doing.
set sudoku101 win32/sudoku101
set sudoku_solver win32/sudoku_solver

