#!/usr/local/bin/wish8.4

source lib/readcompact.tcl
source config.tcl
set ingame 0

proc streq {s1 s2} { return [expr {[string compare $s1 $s2] == 0}] }


if {$argc} {
   set valid [list easy medium hard fiendish]
   set oklevels [list]
   foreach level $argv {
      if {[lsearch -exact $valid $level] >= 0} {
         lappend oklevels $level
      } else {
         tk_messageBox -type ok -message "$level ... not recognized.
Valid levels are easy, medium, hard, and fiendish"
         exit
      }
   }
}

set xlist [list a b c d e f g h i]
set ylist [list a b c d e f g h i]

set i(a) 0 ; set i(b) 1 ; set i(c) 2 ; set i(d) 3 ; set i(e) 4
set i(f) 5 ; set i(g) 6 ; set i(h) 7 ; set i(i) 8

proc debug {str} {
#    console show
#    puts $str
}



proc clearall {} {
   global grid presets

   catch { unset presets }
   foreach x [list a b c d e f g h i] {
      foreach y [list a b c d e f g h i] {
         .grid.$x$y configure -foreground #000000
      }
   }
   set presets [list]

   set grid(aa) "" ; set grid(ba) "" ; set grid(ca) "" ; set grid(da) ""
   set grid(ea) "" ; set grid(fa) "" ; set grid(ga) "" ; set grid(ha) ""
   set grid(ia) "" ; set grid(ab) "" ; set grid(bb) "" ; set grid(cb) ""
   set grid(db) "" ; set grid(eb) "" ; set grid(fb) "" ; set grid(gb) ""
   set grid(hb) "" ; set grid(ib) "" ; set grid(ac) "" ; set grid(bc) ""
   set grid(cc) "" ; set grid(dc) "" ; set grid(ec) "" ; set grid(fc) ""
   set grid(gc) "" ; set grid(hc) "" ; set grid(ic) "" ; set grid(ad) ""
   set grid(bd) "" ; set grid(cd) "" ; set grid(dd) "" ; set grid(ed) ""
   set grid(fd) "" ; set grid(gd) "" ; set grid(hd) "" ; set grid(id) ""
   set grid(ae) "" ; set grid(be) "" ; set grid(ce) "" ; set grid(de) ""
   set grid(ee) "" ; set grid(fe) "" ; set grid(ge) "" ; set grid(he) ""
   set grid(ie) "" ; set grid(af) "" ; set grid(bf) "" ; set grid(cf) ""
   set grid(df) "" ; set grid(ef) "" ; set grid(ff) "" ; set grid(gf) ""
   set grid(hf) "" ; set grid(if) "" ; set grid(ag) "" ; set grid(bg) ""
   set grid(cg) "" ; set grid(dg) "" ; set grid(eg) "" ; set grid(fg) ""
   set grid(gg) "" ; set grid(hg) "" ; set grid(ig) "" ; set grid(ah) ""
   set grid(bh) "" ; set grid(ch) "" ; set grid(dh) "" ; set grid(eh) ""
   set grid(fh) "" ; set grid(gh) "" ; set grid(hh) "" ; set grid(ih) ""
   set grid(ai) "" ; set grid(bi) "" ; set grid(ci) "" ; set grid(di) ""
   set grid(ei) "" ; set grid(fi) "" ; set grid(gi) "" ; set grid(hi) ""
   set grid(ii) ""
}



proc flash {xy {fcnt 5}} {
   set fg [.grid.$xy cget -foreground]
   set bg [.grid.$xy cget -background]
   if {$fcnt == 5} { bell }
   if {[streq $bg #d9d9d9]} {
      set newbg white ; set newfg black
   } else {
      set newbg $fg ; set newfg $bg
   }
   for {set i 0} {$i < $fcnt} {incr i} {
      .grid.$xy configure -insertbackground $newbg -bg $newbg -fg $newfg
      update
      if {$fcnt == 5} { after 250 ; } else { after 20 ; }
      .grid.$xy configure -insertbackground $bg -bg $bg -fg $fg
      update
      if {$fcnt == 5} { after 250 ; }
   }
}

proc check_entry {arrname idx op} {
   global grid gridbackup gridxy xlist ylist ingame

   # find out which x/y col/row we're checking
   if {![regexp {([a-i])([a-i])} $idx a xval yval]} {
      return
   }

   if {[regexp {([0-9])[0-9]} $grid($idx) a orig]} {
      bell
      set grid($idx) $orig
      return
   }


   # if the backup copy of the variable doesn't exist, set to ""
   if {![info exists gridbackup] || ![info exists gridbackup($idx)]} {
      set gridbackup($idx) ""
   }

   # nv == new value being set
   set nv $grid($idx)
   if {[string length $nv] == 0} { return }
   if {[regexp {^[1-9][1-9]*([1-9])$} $nv a new]} {
      set nv $new ; set grid($idx) $new
   }
  if {![regexp {^[1-9]$} $nv]} {
      set grid($idx) $gridbackup($idx)
   }

   # Check the row (horizontal)
   set y $yval
   foreach x $xlist {
      if {[streq $x$y $idx]} { continue }
      if {[streq $grid($x$y) $nv]} {
         flash $x$y
         set grid($idx) $gridbackup($idx)
         return
      }
   }

   # Check the col (vertical)
   set x $xval
   foreach y $ylist {
      if {[streq $x$y $idx]} { continue }
      if {[streq $grid($x$y) $nv]} {
         flash $x$y
         set grid($idx) $gridbackup($idx)
         return
      }
   }

   # find out which grid we're in
   set ab $gridxy($idx) ; set tlist $grid($ab)

   foreach xy $tlist {
      if {[streq $xy $idx]} { continue }
      if {[streq $grid($xy) $nv]} {
         flash $xy
         set grid($idx) $gridbackup($idx)
         return
      }
   }
   set cnt 0
   set ilist [list 1 2 3 4 5 6 7 8 9]
   foreach x { a b c d e f g h i } {
      foreach y { a b c d e f g h i } {
         if {[lsearch -exact $ilist $grid($x$y)] >= 0} { incr cnt }
      }
   }
   if {$cnt == 81} {
      bell
      set ingame 0
      foreach x { a b c d e f g h i } {
         if {$x == "a" || $x == "c" || $x == "e" || $x == "g" || $x == "i"} {
            .mf.slvd configure -text "Solved!" ; update
         } else {
            .mf.slvd configure -text "" ; update
         }
         foreach y { a b c d e f g h i } {
            flash $x$y 1 ; flash $y$x 1
         }
      }
      .mf.slvd configure -text "" ; update
      set ingame 0
      return
   }
   set ingame 1
}

# frame for menus (added a bit later in the file)
pack [frame .mf] -side top -expand y -fill x

pack [frame .grid] -side top

foreach y $ylist {
   foreach x $xlist {
      entry .grid.$x$y -width 2 -relief sunken -font {Times 16 bold} \
         -borderwidth 2 -selectborderwidth 4 -background white -foreground black
      .grid.$x$y configure -textvariable grid($x$y) ; set grid($x$y) ""
      grid .grid.$x$y -row $i($y) -column $i($x) -padx 0 -pady 0
   }
}



# bind All <Control-Key-n> { getboard 1 ; loadnotesboard 1  }
bind Entry <Key-BackSpace> { keybs }
bind Entry <Key-Left> { keyleft }
bind Entry <Key-h> { keyleft }
bind Entry <Key-Right> { keyright }
bind Entry <Key-l> { keyright }
bind Entry <Key-Up> { keyup }
bind Entry <Key-k> { keyup }
bind Entry <Key-Down> { keydown }
bind Entry <Key-j> { keydown }
bind Entry <ButtonPress-3> { focus %W ; solve square }
bind Entry <FocusIn> { %W configure -insertbackground red }
bind Entry <FocusOut> { %W configure -insertbackground white }

proc next {c} {
   switch $c {
      a { return b }
      b { return c }
      c { return d }
      d { return e }
      e { return f }
      f { return g }
      g { return h }
      h { return i }
      i { return a }
   }
}

proc prev {c} {
   switch $c {
      b { return a }
      c { return b }
      d { return c }
      e { return d }
      f { return e }
      g { return f }
      h { return g }
      i { return h }
      a { return i }
   }
}


proc keyleft {} {
   set current [focus]
   if {[regexp {.grid.([a-i])([a-i])} $current a x y]} {
      focus .grid.[prev $x]$y
   } else {
      focus .grid.aa
   }
}


proc keybs {} {
   [focus] configure -state normal
   [focus] delete 0 end
}

proc keyright {} {
   set current [focus]
   if {$current == ""} { focus .grid.aa ; return }
   if {[regexp {.grid.([a-i])([a-i])} $current a x y]} {
      focus .grid.[next $x]$y
   } else {
      focus .grid.aa
   }
}


proc keyup {} {
   set current [focus]
   if {[regexp {.grid.([a-i])([a-i])} $current a x y]} {
      focus .grid.$x[prev $y]
   } else {
      focus .grid.aa
   }
}

proc keydown {} {
   set current [focus]
   if {$current == ""} { focus .grid.aa ; return }
   if {[regexp {.grid.([a-i])([a-i])} $current a x y]} {
      focus .grid.$x[next $y]
   } else {
      focus .grid.aa
   }
}


# We use these in the next two foreach statements to set the bg colors
# on the board (yes, I could shorten this to two lists, but this is
# (IMHO) easier to read).

# top 3 3x3 squares - white grey white
set grid(11) [list aa ba ca ab bb cb ac bc cc]
set grid(12) [list da ea fa db eb fb dc ec fc]
set grid(13) [list ga ha ia gb hb ib gc hc ic]

# middle 3 3x3 squares - grey white grey
set grid(21) [list ad bd cd ae be ce af bf cf]
set grid(22) [list dd ed fd de ee fe df ef ff]
set grid(23) [list gd hd id ge he ie gf hf if]

# bottom 3 3x3 squares - white grey white
set grid(31) [list ag bg cg ah bh ch ai bi ci]
set grid(32) [list dg eg fg dh eh fh di ei fi]
set grid(33) [list gg hg ig gh hh ih gi hi ii]

# Use the above to set the bg colors on the board.

foreach g [list 11 13 22 31 33] {
   foreach xy $grid($g) {
      .grid.$xy configure -insertbackground white -bg white -bd 2
      set gridxy($xy) $g
   }
}

foreach g [list 12 21 23 32] {
   foreach xy $grid($g) {
      .grid.$xy configure -insertbackground #d9d9d9 -bg #d9d9d9 -bd 2
      set gridxy($xy) $g
   }
}


set m .mf
menubutton $m.file -text "File" -menu $m.file.m -font {Times 10 bold} \
   -font {Times 10 bold}
menu $m.file.m -tearoff 0 -font {Times 10 bold} -font {Times 10 bold} \
   -font {Times 10 bold}
if {$tcl_platform(platform) == "windows"} {
   $m.file.m add command -label Console -command { console show }
} else {
   $m.file.m add command -label Console -command { source lib/tkcon_wrap.tcl}
}
$m.file.m add command -label "Load saved board" -command {
   set fn [tk_getOpenFile]
   if {$fn == ""} { return }
   clearall
   source $fn
}

$m.file.m add command -label "Save board" -command {
   set fn [tk_getSaveFile]
   if {$fn == ""} { return }
   set f [open $fn w]
   foreach y $ylist {
      foreach x $xlist {
         set t $grid($x$y)
         if {[string length $t]} { puts $f "set grid($x$y) $t" }
      }
   }
   puts $f ""
   if {[info exists presets]} {
      foreach p $presets {
         foreach {xy t} $p { break }
         puts $f "set grid($xy) $t"
         puts $f ".grid.$xy configure -font {Times 16 bold} -foreground #d90000"
         puts $f "lappend presets \[list $xy $t]"
      }
   }
   puts $f ""
   close $f
}

proc loadnotesboard {{skipifnotloaded 0}} {
   if {![winfo exists .n]} {
      if {$skipifnotloaded} { return }
      source lib/sudonotes.tcl
   }
   foreach x { a b c d e f g h i } {
      foreach y { a b c d e f g h i } {
         setnotes $x $y
      }
   }
}

$m.file.m add command -label "Exit" -command { exit }



menubutton $m.sudoku -text "Sudoku" -menu $m.sudoku.m -font {Times 10 bold}
menu $m.sudoku.m -tearoff 0 -font {Times 10 bold} -font {Times 10 bold}
$m.sudoku.m add command -label "Generate new board" -command { getboard 0 }
$m.sudoku.m add command -label "Update/display notes board" \
   -command { loadnotesboard }
$m.sudoku.m add checkbutton -label "Allow cheats" -variable allow_cheats \
   -onvalue 1 -offvalue 0
$m.sudoku.m add command -label "Solve Board" -command { solve }

$m.sudoku.m add command -label "Clear all" -command { clearall }
$m.sudoku.m add command -label "Set Board (for manual entry)" -command {
   catch { unset presets }
   foreach x [list a b c d e f g h i] {
      foreach y [list a b c d e f g h i] {
         .grid.$x$y configure -foreground #000000
      }
   }
   set presets [list]
   foreach y $ylist {
      foreach x $xlist {
         set t $grid($x$y)
         if {[string length $t]} {
            lappend presets [list $x$y $t]
            .grid.$x$y configure -font {Times 16 bold} \
               -foreground #d90000
         }
      }
   }
}

label $m.slvd -text "" -font {Times 10 bold} -foreground red -anchor center

button $m.new -text {[N]} -font {Times 12 bold} -foreground red \
      -relief flat -command {
         if {$ingame} {
            set ans [tk_messageBox -type yesno -default yes \
                              -message "Really get a new board?  \[Y/n]  "]
            if {$ans == "yes"} { set ingame 0 }
         }
         if {!$ingame} { nclearall ; getboard 1 ; loadnotesboard }
      }

button $m.upd -text {[U]} -font {Times 12 bold} -foreground red \
      -relief flat -command { loadnotesboard ; set ingame 1 }
button $m.info -text "About" -relief flat -font {Times 10 bold} -command {
   tk_messageBox -type ok -message {
This is a Tcl/Tk + C based Sudoku generator/puzzle board.  The C
code (compiled to sudoku101.exe) generates the board (and has many
other options, and can be used by itself to generate Sudoku boards
for printing, etc.---run it as "sudoku101 --help" for info/options).
The C portion is a stripped-down version of the curses-based, Unix
version, which includes its own interface.  The original C code is
the work of Michael Kennett (mike at laurasia.com.au), and I am
to blame for the butchered version used here.

Actually, now there's another external program used here, as well.
It's called sudoku_solver, and it's also from the Unix world.

The Tcl/Tk code is the display, and is by me, Jim Graham, N5IAL.}
}

pack $m.file $m.sudoku $m.new $m.upd -side left -expand n
pack $m.slvd -side left -expand y -fill x
pack $m.info -side left -expand n

wm geometry .  252x303+69+7
update
getboard 1
loadnotesboard
wm geometry .n 486x470+345+0
update

trace variable grid w check_entry


